// Copyright 2018 The Go Authors. All rights reserved.
// Use of this source code is governed by a BSD-style
// license that can be found in the LICENSE file.

// +build sw64

#include <asm/regdef.h>
/*
 * void crosscall1(void (*fn)(void), void (*setg_gcc)(void *g), void *g)
 *
 * Calling into the gc tool chain, where all registers are caller save.
 * Called from standard SW_64 ABI, where $9-$14, are callee-save,
 * so they must be saved explicitly, along with $26 (RA).
 * TODO_snyh: sp, gp ?
 */

    .set noat
    .align 2
    .globl crosscall1
    .ent crosscall1
crosscall1:

	.frame fp, 16, ra, 0
    .cfi_startproc
    ldi sp, -160(sp)
	.cfi_def_cfa_offset 160

    stl $26, 0(sp)
    stl $15, 56(sp)
	stl $29, 64(sp)
	.cfi_offset 26, -16
	.cfi_offset 15, -56
    mov sp, $15
   	.cfi_def_cfa_register 15
	.prologue 0

	stl  $9, 8(sp)
	stl	 $10, 16(sp)
	stl	 $11, 24(sp)
	stl	 $12, 32(sp)
	stl	 $13, 40(sp)
	stl	 $14, 48(sp)

	fstd $f2, 88 (sp)
	fstd $f3, 96 (sp)
	fstd $f4, 104(sp)
	fstd $f5, 112(sp)
	fstd $f6, 120(sp)
	fstd $f7, 128(sp)
	fstd $f8, 136(sp)
	fstd $f9, 144(sp)

# snyh_TODO: prepare SB register = 0

    #a0=fn, a1=setg_gcc, a2=g
    stl a0, 72(sp)

    ldi $27, 0(a1)
    ldi a0, 0(a2)
    ldi a1, 0(zero)
    ldi a2, 0(zero)
	call $26, ($27), 0  #call setg_gcc (clobbers A0 ?)

    ldl $27, 72(sp)
    ldi a0, 0(zero)
    ldi a1, 0(zero)
    ldi a2, 0(zero)
	call $26, ($27), 0  #call fn

	ldl  $9, 8(sp)
	ldl	 $10, 16(sp)
	ldl	 $11, 24(sp)
	ldl	 $12, 32(sp)
	ldl	 $13, 40(sp)
	ldl	 $14, 48(sp)

	ldl  $15, 56(sp)
	.cfi_restore 15

	fldd $f2, 88 (sp)
	fldd $f3, 96 (sp)
	fldd $f4, 104(sp)
	fldd $f5, 112(sp)
	fldd $f6, 120(sp)
	fldd $f7, 128(sp)
	fldd $f8, 136(sp)
	fldd $f9, 144(sp)

	ldl $29, 64(sp)

	ldl	$26, 0(sp)
	.cfi_restore 26

    ldi sp, 160(sp)
	.cfi_def_cfa 30, 0

	ret $31,($26),1
	.cfi_endproc

    .end crosscall1